# 
#           MuPIF: Multi-Physics Integration Framework 
#               Copyright (C) 2010-2015 Borek Patzak
# 
#    Czech Technical University, Faculty of Civil Engineering,
#  Department of Structural Mechanics, 166 29 Prague, Czech Republic
# 
# This library is free software; you can redistribute it and/or
# modify it under the terms of the GNU Lesser General Public
# License as published by the Free Software Foundation; either
# version 2.1 of the License, or (at your option) any later version.
# 
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# Lesser General Public License for more details.
# 
# You should have received a copy of the GNU Lesser General Public
# License along with this library; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, 
# Boston, MA  02110-1301  USA
#

import Pyro4
import json
import pprint
    
    
@Pyro4.expose
class MValType:
    def __init__(self, type, compulsory):
        self.valType = type
        self.compulsory = compulsory
    def __repr__(self): #hide details when printing a dictionary
        return (self.valType.__name__)
    
    def flattenDict(self, init, lkey=''):
        ret = {}
        for rkey,val in init.items():
            key = lkey+rkey
            if isinstance(val, dict):
                ret.update(flattenDict(val, key+'.'))
            else:
                ret[key] = val
        return ret
    
    def validate(self):
        None
    
    def compare(self, MDTemplate1, MD1):
        for key, val in MD1.items():
            try:#print (key, val)
                if not key in MDTemplate1:
                    raise KeyError('Key %s not found in template dictionary' % key)
                elif (MDTemplate1.get(key).valType != type(val)):
                    print('Key %s=%s should be of type %s' % (key, val, MDTemplate1.get(key).valType))
                else:
                    print (key, val)
                    #print(MDTemplateDict1.get(key, "Not Found ! "))
            except KeyError as error:
                print(error)
                raise
        print('All checks passed.')
        
    
        
